Index: /trunk/src/sh_database.c
===================================================================
--- /trunk/src/sh_database.c	(revision 584)
+++ /trunk/src/sh_database.c	(revision 1)
@@ -33,6 +33,4 @@
 /* #define DB_DEBUG  */
 
-#define SH_REAL_SET
-
 #include "samhain.h"
 
@@ -51,5 +49,4 @@
   int    val;
   int    size;
-  int    alen;
   size_t off;
 } my_attr;
@@ -61,5 +58,5 @@
   char            msg[1024];
   char            sev[8];
-  char            path[MAX_PATH_STORE+1];
+  char            path[12288];
   char            user[9];
   char            group[9];
@@ -75,5 +72,5 @@
   char            module[8];
   char            syscall[16];
-  char            ip[SH_IP_BUF];     
+  char            ip[16];     
   char            tty[16];    
   char            peer[64];
@@ -82,6 +79,6 @@
   char            interface[64];   
   char            ltime[64];   
-  char            dir[MAX_PATH_STORE+1];   
-  char            linked_path[MAX_PATH_STORE+1]; 
+  char            dir[1024];   
+  char            linked_path[1024]; 
   char            service[64];   
   char            facility[32];   
@@ -107,10 +104,8 @@
   char            chksum_old[50];
   char            chksum_new[50];
-  char            link_old[MAX_PATH_STORE+1];
-  char            link_new[MAX_PATH_STORE+1];
-  char            acl_old[1024];
-  char            acl_new[1024];
-
-  unsigned long   ulong_data[20];
+  char            link_old[1024];
+  char            link_new[1024];
+
+  long            long_data[20];
 
   /*
@@ -125,105 +120,90 @@
 } dbins;
 
-static my_attr * attr_tab_srch = NULL;
-static int       attr_tab_srch_siz = 0;
-
 static my_attr attr_tab[] = {
-  { NULL, N_("sev"),         0,   1,    8, 0, offsetof(struct dbins_, sev) },
-  { NULL, N_("tstamp"),      0,   2,   16, 0, offsetof(struct dbins_, time) },
-  { NULL, N_("remote_host"), 0,   3,   64, 0, offsetof(struct dbins_, host) },
-  { NULL, N_("msg"),         0,   4, 1024, 0, offsetof(struct dbins_, msg) },
-
-  { NULL, N_("path"),        0,   5,MAX_PATH_STORE+1, 0, offsetof(struct dbins_, path)  },
+  { NULL, N_("sev"),         0,   1,    8, offsetof(struct dbins_, sev) },
+  { NULL, N_("tstamp"),      0,   2,   16, offsetof(struct dbins_, time) },
+  { NULL, N_("remote_host"), 0,   3,   64, offsetof(struct dbins_, host) },
+  { NULL, N_("msg"),         0,   4, 1024, offsetof(struct dbins_, msg) },
+
+  { NULL, N_("path"),        0,   5,12288, offsetof(struct dbins_, path)  },
   /* username -> userid; replace (long) 'userid' - below - by 'dummy' */ 
-  { NULL, N_("userid"),      0,   6,    9, 0, offsetof(struct dbins_, user)  },
-  { NULL, N_("group"),       0,   7,    9, 0, offsetof(struct dbins_, group)  },
-  { NULL, N_("program"),     0,   8,    8, 0, offsetof(struct dbins_, program)  },
-  { NULL, N_("subroutine"),  0,   9,   16, 0, offsetof(struct dbins_, subroutine)},
-  { NULL, N_("status"),      0,  10,   12, 0, offsetof(struct dbins_, status)  },
-  { NULL, N_("hash"),        0,  11,   50, 0, offsetof(struct dbins_, hash)  },
-  { NULL, N_("path_data"),   0,  12, 1024, 0, offsetof(struct dbins_, path_data)  },
-  { NULL, N_("hash_data"),   0,  13,   50, 0, offsetof(struct dbins_, hash_data)  },
-  { NULL, N_("key_uid"),     0,  14,   64, 0, offsetof(struct dbins_, key_uid)  },
-  { NULL, N_("key_uid_data"),0,  15,   64, 0, offsetof(struct dbins_, key_uid_data)},
-  { NULL, N_("key_id"),      0,  16,   16, 0, offsetof(struct dbins_, key_id)  },
-  { NULL, N_("module"),      0,  17,    8, 0, offsetof(struct dbins_, module)  },
-  { NULL, N_("syscall"),     0,  19,   16, 0, offsetof(struct dbins_, syscall)  },
-  { NULL, N_("ip"),          0,  20,SH_IP_BUF, 0, offsetof(struct dbins_, ip)  },
-  { NULL, N_("tty"),         0,  21,   16, 0, offsetof(struct dbins_, tty)  },
-  { NULL, N_("peer"),        0,  22,   64, 0, offsetof(struct dbins_, peer)  },
-  { NULL, N_("obj"),         0,  23, 1024, 0, offsetof(struct dbins_, obj)  },
-  { NULL, N_("interface"),   0,  24,   64, 0, offsetof(struct dbins_, interface)},
-  { NULL, N_("time"),        0,  25,   64, 0, offsetof(struct dbins_, ltime)  },
-  { NULL, N_("dir"),         0,  26, MAX_PATH_STORE+1, 0, offsetof(struct dbins_, dir)  },
-  { NULL, N_("linked_path"), 0,  27, MAX_PATH_STORE+1, 0, offsetof(struct dbins_, linked_path)},
-  { NULL, N_("service"),     0,  29,   64, 0, offsetof(struct dbins_, service)},
-  { NULL, N_("facility"),    0,  30,   32, 0, offsetof(struct dbins_, facility) },
-  { NULL, N_("priority"),    0,  31,   32, 0, offsetof(struct dbins_, priority) },
-  { NULL, N_("syslog_msg"),  0,  32, 1024, 0, offsetof(struct dbins_, syslog_msg)  },
-
-  { NULL, N_("mode_old"),    0,  33,   16, 0, offsetof(struct dbins_, mode_old) },
-  { NULL, N_("mode_new"),    0,  34,   16, 0, offsetof(struct dbins_, mode_new) },
-  { NULL, N_("device_old"),  0,  35,   16, 0, offsetof(struct dbins_, device_old)}, 
-  { NULL, N_("device_new"),  0,  36,   16, 0, offsetof(struct dbins_, device_new)},
-  { NULL, N_("owner_old"),   0,  37,    9, 0, offsetof(struct dbins_, owner_old)},
-  { NULL, N_("owner_new"),   0,  38,    9, 0, offsetof(struct dbins_, owner_new)},
-  { NULL, N_("group_old"),   0,  39,    9, 0, offsetof(struct dbins_, group_old)},
-  { NULL, N_("group_new"),   0,  40,    9, 0, offsetof(struct dbins_, group_new)},
-  { NULL, N_("ctime_old"),   0,  41,   20, 0, offsetof(struct dbins_, ctime_old)},
-  { NULL, N_("ctime_new"),   0,  42,   20, 0, offsetof(struct dbins_, ctime_new)},
-  { NULL, N_("atime_old"),   0,  43,   20, 0, offsetof(struct dbins_, atime_old)},
-  { NULL, N_("atime_new"),   0,  44,   20, 0, offsetof(struct dbins_, atime_new)},
-  { NULL, N_("mtime_old"),   0,  45,   20, 0, offsetof(struct dbins_, mtime_old)},
-  { NULL, N_("mtime_new"),   0,  46,   20, 0, offsetof(struct dbins_, mtime_new)},
-  { NULL, N_("chksum_old"),  0,  47,   50, 0, offsetof(struct dbins_, chksum_old)},
-  { NULL, N_("chksum_new"),  0,  48,   50, 0, offsetof(struct dbins_, chksum_new)},
-  { NULL, N_("link_old"),    0,  49, MAX_PATH_STORE+1, 0, offsetof(struct dbins_, link_old)},
-  { NULL, N_("link_new"),    0,  50, MAX_PATH_STORE+1, 0, offsetof(struct dbins_, link_new)},
-
-  /* These go into  dbins.ulong_data[n - START_SEC_LONGS] */             				    
-  { NULL, N_("size_old"),     0,  51,    0, 0, 0  },
-  { NULL, N_("size_new"),     0,  52,    0, 0, 0  },
-  { NULL, N_("hardlinks_old"),0,  53,    0, 0, 0  },
-  { NULL, N_("hardlinks_new"),0,  54,    0, 0, 0  },
-  { NULL, N_("inode_old"),    0,  55,    0, 0, 0  }, 
-  { NULL, N_("inode_new"),    0,  56,    0, 0, 0  }, 
-					    
-  { NULL, N_("imode_old"),    0,  57,    0, 0, 0  },
-  { NULL, N_("imode_new"),    0,  58,    0, 0, 0  },
-  { NULL, N_("iattr_old"),    0,  59,    0, 0, 0  },
-  { NULL, N_("iattr_new"),    0,  60,    0, 0, 0  },
-  { NULL, N_("idevice_old"),  0,  61,    0, 0, 0  }, 
-  { NULL, N_("idevice_new"),  0,  62,    0, 0, 0  }, 
-  { NULL, N_("iowner_old"),   0,  63,    0, 0, 0  },
-  { NULL, N_("iowner_new"),   0,  64,    0, 0, 0  },
-  { NULL, N_("igroup_old"),   0,  65,    0, 0, 0  },
-  { NULL, N_("igroup_new"),   0,  66,    0, 0, 0  },
-
-  { NULL, N_("port"),         0,  67,    0, 0, 0  },
-  { NULL, N_("return_code"),  0,  68,    0, 0, 0  },
-
-  { NULL, N_("checkflags_old"), 0,  69,    0, 0, 0  },
-  { NULL, N_("checkflags_new"), 0,  70,    0, 0, 0  },
-
-  /* END_SEC_LONGS                                         */
-
-  { NULL, N_("host"),         0,  71,   64, 0, offsetof(struct dbins_, fromhost)},
-  { NULL, N_("attr_old"),     0,  72,   16, 0, offsetof(struct dbins_, attr_old)},
-  { NULL, N_("attr_new"),     0,  73,   16, 0, offsetof(struct dbins_, attr_new)},
-  { NULL, N_("acl_old"),      0,  74, 1024, 0, offsetof(struct dbins_, acl_old)},
-  { NULL, N_("acl_new"),      0,  75, 1024, 0, offsetof(struct dbins_, acl_new)},
-
-  { NULL, NULL,      0,  0, 0, 0, 0 }
+  { NULL, N_("userid"),      0,   6,    9, offsetof(struct dbins_, user)  },
+  { NULL, N_("group"),       0,   7,    9, offsetof(struct dbins_, group)  },
+  { NULL, N_("program"),     0,   8,    8, offsetof(struct dbins_, program)  },
+  { NULL, N_("subroutine"),  0,   9,   16, offsetof(struct dbins_, subroutine)},
+  { NULL, N_("status"),      0,  10,   12, offsetof(struct dbins_, status)  },
+  { NULL, N_("hash"),        0,  11,   50, offsetof(struct dbins_, hash)  },
+  { NULL, N_("path_data"),   0,  12, 1024, offsetof(struct dbins_, path_data)  },
+  { NULL, N_("hash_data"),   0,  13,   50, offsetof(struct dbins_, hash_data)  },
+  { NULL, N_("key_uid"),     0,  14,   64, offsetof(struct dbins_, key_uid)  },
+  { NULL, N_("key_uid_data"),0,  15,   64, offsetof(struct dbins_, key_uid_data)},
+  { NULL, N_("key_id"),      0,  16,   16, offsetof(struct dbins_, key_id)  },
+  { NULL, N_("module"),      0,  17,    8, offsetof(struct dbins_, module)  },
+  { NULL, N_("syscall"),     0,  19,   16, offsetof(struct dbins_, syscall)  },
+  { NULL, N_("ip"),          0,  20,   16, offsetof(struct dbins_, ip)  },
+  { NULL, N_("tty"),         0,  21,   16, offsetof(struct dbins_, tty)  },
+  { NULL, N_("peer"),        0,  22,   64, offsetof(struct dbins_, peer)  },
+  { NULL, N_("obj"),         0,  23, 1024, offsetof(struct dbins_, obj)  },
+  { NULL, N_("interface"),   0,  24,   64, offsetof(struct dbins_, interface)},
+  { NULL, N_("time"),        0,  25,   64, offsetof(struct dbins_, ltime)  },
+  { NULL, N_("dir"),         0,  26, 1024, offsetof(struct dbins_, dir)  },
+  { NULL, N_("linked_path"), 0,  27, 1024, offsetof(struct dbins_, linked_path)},
+  { NULL, N_("service"),     0,  29,   64, offsetof(struct dbins_, service)},
+  { NULL, N_("facility"),    0,  30,   32, offsetof(struct dbins_, facility) },
+  { NULL, N_("priority"),    0,  31,   32, offsetof(struct dbins_, priority) },
+  { NULL, N_("syslog_msg"),  0,  32, 1024, offsetof(struct dbins_, syslog_msg)  },
+
+  { NULL, N_("mode_old"),    0,  33,   16, offsetof(struct dbins_, mode_old) },
+  { NULL, N_("mode_new"),    0,  34,   16, offsetof(struct dbins_, mode_new) },
+  { NULL, N_("device_old"),  0,  35,   16, offsetof(struct dbins_, device_old)}, 
+  { NULL, N_("device_new"),  0,  36,   16, offsetof(struct dbins_, device_new)},
+  { NULL, N_("owner_old"),   0,  37,    9, offsetof(struct dbins_, owner_old)},
+  { NULL, N_("owner_new"),   0,  38,    9, offsetof(struct dbins_, owner_new)},
+  { NULL, N_("group_old"),   0,  39,    9, offsetof(struct dbins_, group_old)},
+  { NULL, N_("group_new"),   0,  40,    9, offsetof(struct dbins_, group_new)},
+  { NULL, N_("ctime_old"),   0,  41,   20, offsetof(struct dbins_, ctime_old)},
+  { NULL, N_("ctime_new"),   0,  42,   20, offsetof(struct dbins_, ctime_new)},
+  { NULL, N_("atime_old"),   0,  43,   20, offsetof(struct dbins_, atime_old)},
+  { NULL, N_("atime_new"),   0,  44,   20, offsetof(struct dbins_, atime_new)},
+  { NULL, N_("mtime_old"),   0,  45,   20, offsetof(struct dbins_, mtime_old)},
+  { NULL, N_("mtime_new"),   0,  46,   20, offsetof(struct dbins_, mtime_new)},
+  { NULL, N_("chksum_old"),  0,  47,   50, offsetof(struct dbins_, chksum_old)},
+  { NULL, N_("chksum_new"),  0,  48,   50, offsetof(struct dbins_, chksum_new)},
+  { NULL, N_("link_old"),    0,  49, 1024, offsetof(struct dbins_, link_old)},
+  { NULL, N_("link_new"),    0,  50, 1024, offsetof(struct dbins_, link_new)},
+               
+  { NULL, N_("size_old"),     0,  51,    0, 0  },
+  { NULL, N_("size_new"),     0,  52,    0, 0  },
+  { NULL, N_("hardlinks_old"),0,  53,    0, 0  },
+  { NULL, N_("hardlinks_new"),0,  54,    0, 0  },
+  { NULL, N_("inode_old"),    0,  55,    0, 0  }, 
+  { NULL, N_("inode_new"),    0,  56,    0, 0  }, 
+
+  { NULL, N_("imode_old"),    0,  57,    0, 0  },
+  { NULL, N_("imode_new"),    0,  58,    0, 0  },
+  { NULL, N_("iattr_old"),    0,  59,    0, 0  },
+  { NULL, N_("iattr_new"),    0,  60,    0, 0  },
+  { NULL, N_("idevice_old"),  0,  61,    0, 0  }, 
+  { NULL, N_("idevice_new"),  0,  62,    0, 0  }, 
+  { NULL, N_("iowner_old"),   0,  63,    0, 0  },
+  { NULL, N_("iowner_new"),   0,  64,    0, 0  },
+  { NULL, N_("igroup_old"),   0,  65,    0, 0  },
+  { NULL, N_("igroup_new"),   0,  66,    0, 0  },
+
+  { NULL, N_("port"),         0,  67,    0, 0  },
+  { NULL, N_("return_code"),  0,  68,    0, 0  },
+  /* { NULL, N_("userid"),        0,  69,    0, 0  }, old 'userid', 1.8.1 */
+
+  { NULL, N_("host"),         0,  70,   64, offsetof(struct dbins_, fromhost)},
+  { NULL, N_("attr_old"),     0,  71,   16, offsetof(struct dbins_, attr_old)},
+  { NULL, N_("attr_new"),     0,  72,   16, offsetof(struct dbins_, attr_new)},
+
+  { NULL, NULL,      0,  0, 0, 0 }
 };
 
-#define SH_SLOT_CHECKFLAGS 69
-
-/* need special attention b/o reserved SQL words    */
-#define SH_SLOT_HOST    71
+#define SH_SLOT_HOST    70
 #define SH_SLOT_GROUP    7
-
-/* these go into dbins.ulong_data[n-START_SEC_LONGS */
 #define START_SEC_LONGS 51
-#define END_SEC_LONGS   70
+#define END_SEC_LONGS   68
 
 #if defined(HAVE_INT_32)
@@ -239,15 +219,13 @@
 typedef unsigned char uint8;
 
-typedef struct md5_ctx
-{
-  uint32 A;
-  uint32 B;
-  uint32 C;
-  uint32 D;
-
-  uint32 total[2];
-  uint32 buflen;
-  char buffer[128];
+typedef struct
+{
+        uint32 h[4];
+        uint32 data[16];
+        uint8  offset;
+        uint32  nblocks;
+        int  count;
 } md5Param;
+
 
 
@@ -267,10 +245,10 @@
 static int  sh_persistent_dbconn = S_TRUE;
 
-int sh_database_use_persistent (const char * str)
+int sh_database_use_persistent (char * str)
 {
   return sh_util_flagval (str, &sh_persistent_dbconn);
 }
 
-static int insert_value (char * ptr, const char * str)
+static int insert_value (char * ptr, char * str)
 {
   if (!ptr || !str)
@@ -284,5 +262,5 @@
 static void init_db_entry (dbins * ptr)
 {
-  memset (ptr, 0, sizeof(dbins));
+  memset (ptr, (int) '\0', sizeof(dbins));
   ptr->next = NULL;
   return;
@@ -290,21 +268,21 @@
   
 
-int sh_database_set_database (const char * str)
+int sh_database_set_database (char * str)
 {
   return insert_value (db_name, str);
 }
-int sh_database_set_table (const char * str)
+int sh_database_set_table (char * str)
 {
   return insert_value (db_table, str);
 }
-int sh_database_set_host (const char * str)
+int sh_database_set_host (char * str)
 {
   return insert_value (db_host, str);
 }
-int sh_database_set_user (const char * str)
+int sh_database_set_user (char * str)
 {
   return insert_value (db_user, str);
 }
-int sh_database_set_password (const char * str)
+int sh_database_set_password (char * str)
 {
   return insert_value (db_password, str);
@@ -511,5 +489,4 @@
 static    OCIError  * o_error = NULL;
 static    OCIStmt   * o_statement;
-static    OCIBind   * o_bind = (OCIBind *) 0;
 static    text        o_errormsg[512];
 static    sb4         o_errorcode;
@@ -537,5 +514,5 @@
     {
       if (str[len-1] == '\n')
-	str[len-1] = '\0';
+	str[len-1] == '\0';
     }
   return str;
@@ -549,6 +526,4 @@
   char         row_query[128];
   int          retry     = 0;
-  static SH_TIMEOUT sh_timer = { 0, 3600, S_TRUE };
-
 
   SL_ENTER(_("sh_database_query"));
@@ -585,5 +560,5 @@
  oracle_doconnect:
 
-  if (!getenv("ORACLE_HOME")) /* flawfinder: ignore */
+  if (!getenv("ORACLE_HOME")) 
     {
       sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
@@ -648,39 +623,27 @@
 	       (OraText*) db_password, sl_strlen(db_password), 
 	       (OraText*) db_name,     sl_strlen(db_name))) 
-      {
-   
-	connected = 0;
-
-	sh_timer.flag_ok = S_FALSE;
-
-	if (S_TRUE == sh_util_timeout_check(&sh_timer))
-	  {
-	    OCIErrorGet(o_error, 1, NULL, &o_errorcode, 
-			o_errormsg, sizeof(o_errormsg), OCI_HTYPE_ERROR);
-	    sh_stripnl (o_errormsg);
-	    sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			    o_errormsg, 
-			    _("sh_database_query"));
-	    sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			    _("check database is listed in tnsnames.ora"), 
-			    _("sh_database_query"));
-	    sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			    _("check tnsnames.ora readable"), 
-			    _("sh_database_query"));
-	    sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			    _("check database accessible with sqlplus"), 
-			    _("sh_database_query"));
-	    sl_snprintf(row_query, 127, 
-			_("OCILogon: Connection to database '%s' failed"), 
-			db_name); 
-	    sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN, 
-			    row_query, _("sh_database_query")); 
-
-	    goto err_out;
-	  }
-	else
-	  {
-	    SL_RETURN(0, _("sh_database_query"));
-	  }
+      {   
+	OCIErrorGet(o_error, 1, NULL, &o_errorcode, 
+		    o_errormsg, sizeof(o_errormsg), OCI_HTYPE_ERROR);
+	sh_stripnl (o_errormsg);
+	sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
+			o_errormsg, 
+			_("sh_database_query"));
+	sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
+			_("check database is listed in tnsnames.ora"), 
+			_("sh_database_query"));
+	sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
+			_("check tnsnames.ora readable"), 
+			_("sh_database_query"));
+	sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
+			_("check database accessible with sqlplus"), 
+			_("sh_database_query"));
+	sl_snprintf(row_query, 127, 
+		    _("OCILogon: Connection to database '%s' failed"), 
+		    db_name); 
+	sh_error_handle((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN, 
+			row_query, _("sh_database_query")); 
+	bad_init = 1;
+	SL_RETURN(-1, _("sh_database_query")); 
       }
  
@@ -695,16 +658,15 @@
  oracle_connected:
 
-  /* Get row index
-   */
-  sl_strlcpy (row_query, _("SELECT log_log_index_seq.NEXTVAL FROM dual"), 128);
-
+  /* 
+   * Insert
+   */
 #ifdef DB_DEBUG
   sh_error_handle(SH_ERR_NOTICE, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		  row_query, 
+		  query, 
 		  _("sh_database_query"));
 #endif
 
   if (OCIStmtPrepare(o_statement, o_error, 
-		     (OraText*) row_query, sl_strlen(row_query), 
+		     (OraText*) query, sl_strlen(query), 
 		     OCI_NTV_SYNTAX, OCI_DEFAULT))
     {
@@ -717,5 +679,5 @@
 		      _("sh_database_query"));
       if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
+	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9)) 
 	  { 
 	    ++retry; sh_database_reset(); goto oracle_doconnect; 
@@ -723,7 +685,8 @@
       goto err_out;
     }
-
-  if (OCIStmtExecute(o_servicecontext, o_statement, o_error, 
-		     0, 0, NULL, NULL, OCI_DEFAULT))
+ 
+   if (OCIStmtExecute(o_servicecontext, 
+		      o_statement, o_error, 1,  0, 
+		      NULL, NULL, OCI_COMMIT_ON_SUCCESS))
     {
       OCIErrorGet(o_error, 1, NULL, 
@@ -735,5 +698,5 @@
 		      _("sh_database_query"));
       if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
+	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9)) 
 	  { 
 	    ++retry; sh_database_reset(); goto oracle_doconnect; 
@@ -742,7 +705,24 @@
     }
 
-  if (OCIDefineByPos (o_statement, &o_define, o_error, 1, 
-		      &result, sizeof(result), 
-		      SQLT_INT, 0, 0, 0, OCI_DEFAULT))
+#ifdef DB_DEBUG
+  sh_error_handle(SH_ERR_NOTICE, FIL__, __LINE__, 0, MSG_E_SUBGEN,
+		  _("No error on insert"), 
+		  _("sh_database_query"));
+#endif
+
+  /* Get row index
+   */
+  sl_strlcpy (row_query, _("SELECT MAX(log_index) FROM "), 128);
+  sl_strlcat (row_query, db_table, 128);
+
+#ifdef DB_DEBUG
+  sh_error_handle(SH_ERR_NOTICE, FIL__, __LINE__, 0, MSG_E_SUBGEN,
+		  row_query, 
+		  _("sh_database_query"));
+#endif
+
+  if (OCIStmtPrepare(o_statement, o_error, 
+		     (OraText*) row_query, sl_strlen(row_query), 
+		     OCI_NTV_SYNTAX, OCI_DEFAULT))
     {
       OCIErrorGet(o_error, 1, NULL, 
@@ -754,5 +734,5 @@
 		      _("sh_database_query"));
       if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
+	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9)) 
 	  { 
 	    ++retry; sh_database_reset(); goto oracle_doconnect; 
@@ -760,5 +740,7 @@
       goto err_out;
     }
-  if (OCIStmtFetch (o_statement, o_error, 1, OCI_FETCH_NEXT, OCI_DEFAULT))
+
+  if (OCIStmtExecute(o_servicecontext, o_statement, o_error, 
+		     0, 0, NULL, NULL, OCI_DEFAULT))
     {
       OCIErrorGet(o_error, 1, NULL, 
@@ -770,5 +752,5 @@
 		      _("sh_database_query"));
       if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
+	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9)) 
 	  { 
 	    ++retry; sh_database_reset(); goto oracle_doconnect; 
@@ -776,25 +758,8 @@
       goto err_out;
     }
-  
-#ifdef DB_DEBUG
-  sl_snprintf(row_query, 127, _("Returned value: %d"), result); 
-  sh_error_handle(SH_ERR_NOTICE, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		  row_query, 
-		  _("sh_database_query"));
-#endif
-
-  *id = result;
-
-  /* do the insert
-   */
-#ifdef DB_DEBUG
-  sh_error_handle(SH_ERR_NOTICE, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		  query, 
-		  _("sh_database_query"));
-#endif
-
-  if (OCIStmtPrepare(o_statement, o_error, 
-		     (OraText*) query, sl_strlen(query), 
-		     OCI_NTV_SYNTAX, OCI_DEFAULT))
+
+  if (OCIDefineByPos (o_statement, &o_define, o_error, 1, 
+		      &result, sizeof(result), 
+		      SQLT_INT, 0, 0, 0, OCI_DEFAULT))
     {
       OCIErrorGet(o_error, 1, NULL, 
@@ -806,14 +771,11 @@
 		      _("sh_database_query"));
       if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
-	{ 
-	  ++retry; sh_database_reset(); goto oracle_doconnect; 
-	}
+	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9)) 
+	  { 
+	    ++retry; sh_database_reset(); goto oracle_doconnect; 
+	  }
       goto err_out;
     }
- 
-  if (OCIBindByPos(o_statement, &o_bind, o_error, 1,
-		   (dvoid *) &result, (sword) sizeof(result), SQLT_INT, 
-		   (dvoid *) 0, (ub2 *) 0, (ub2 *) 0, (ub4) 0, (ub4 *) 0, OCI_DEFAULT))
+  if (OCIStmtFetch (o_statement, o_error, 1, OCI_FETCH_NEXT, OCI_DEFAULT))
     {
       OCIErrorGet(o_error, 1, NULL, 
@@ -825,5 +787,5 @@
 		      _("sh_database_query"));
       if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
+	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9)) 
 	  { 
 	    ++retry; sh_database_reset(); goto oracle_doconnect; 
@@ -831,29 +793,13 @@
       goto err_out;
     }
-
-   if (OCIStmtExecute(o_servicecontext, 
-		      o_statement, o_error, 1,  0, 
-		      NULL, NULL, OCI_COMMIT_ON_SUCCESS))
-    {
-      OCIErrorGet(o_error, 1, NULL, 
-		  &o_errorcode, o_errormsg, sizeof(o_errormsg), 
-		  OCI_HTYPE_ERROR);
-      sh_stripnl (o_errormsg);
-      sh_error_handle((-1), FIL__, __LINE__, (long) o_errorcode, MSG_E_SUBGEN,
-		      o_errormsg, 
-		      _("sh_database_query"));
-      if (retry == 0 && 
-	  (3114 == o_errorcode || 0 == strncmp(o_errormsg, _("ORA-03114"), 9))) 
-	  { 
-	    ++retry; sh_database_reset(); goto oracle_doconnect; 
-	  }
-      goto err_out;
-    }
-
+  
 #ifdef DB_DEBUG
+  sl_snprintf(row_query, 127, _("Returned value: %d"), result); 
   sh_error_handle(SH_ERR_NOTICE, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		  _("No error on insert"), 
+		  row_query, 
 		  _("sh_database_query"));
 #endif
+
+  *id = result;
 
   if (sh_persistent_dbconn == S_FALSE)
@@ -872,6 +818,13 @@
    * Error
    */
-  sh_database_reset();
-
+  if (sh_persistent_dbconn == S_FALSE)
+    {
+      OCILogoff(o_servicecontext, o_error);
+      OCIHandleFree((dvoid *) o_statement,      OCI_HTYPE_STMT);
+      OCIHandleFree((dvoid *) o_servicecontext, OCI_HTYPE_SVCCTX);
+      OCIHandleFree((dvoid *) o_error,          OCI_HTYPE_ERROR);
+      o_error = NULL;
+      connected = 0;
+    }
   SL_RETURN(-1, _("sh_database_query"));
 }
@@ -887,14 +840,8 @@
  ******************************************************************/
 
-#if defined(HAVE_PGSQL_LIBPQ_FE_H)
+#ifdef HAVE_PGSQL_LIBPQ_FE_H
 #include <pgsql/libpq-fe.h>
-#elif defined(HAVE_POSTGRESQL_LIBPQ_FE_H)
-#include <postgresql/libpq-fe.h>
 #else
-#if !defined(USE_UNO)
 #include <libpq-fe.h>
-#else
-#include <postgresql/libpq-fe.h>
-#endif
 #endif
 
@@ -915,6 +862,4 @@
   PGresult        * res;
   unsigned int      i;
-  const char      * params[1];
-  char              id_param[32];
   static SH_TIMEOUT sh_timer = { 0, 3600, S_TRUE };
 
@@ -987,29 +932,26 @@
 
 
-  /* get the unique row index
-   */
-  res = PQexec(conn, _("SELECT NEXTVAL('log_log_index_seq')"));
-  if (PQresultStatus(res) != PGRES_TUPLES_OK) 
+  /* do the insert
+   */
+  res = PQexec(conn, query);
+  if (PQresultStatus(res) != PGRES_COMMAND_OK) 
     {
       PQclear(res);
       goto err_out;
     }
-
-  *id = atoi (PQgetvalue(res, 0, 0)); 
   PQclear(res);
 
-  sl_snprintf(id_param, 32, "%ld", *id);
-  params[0] = id_param;
-
-  /* do the insert
-   */
-  res = PQexecParams(conn, query, 1, NULL, params, NULL, NULL, 1);
-  if (PQresultStatus(res) != PGRES_COMMAND_OK) 
+  /* get the unique row index
+   */
+  res = PQexec(conn, _("SELECT last_value FROM log_log_index_seq"));
+  if (PQresultStatus(res) != PGRES_TUPLES_OK) 
     {
       PQclear(res);
       goto err_out;
     }
+
+  *id = atoi (PQgetvalue(res, 0, 0)); 
+
   PQclear(res);
-
   if (S_FALSE == sh_persistent_dbconn)
     {
@@ -1057,5 +999,5 @@
 static int        connection_status = S_FALSE;
 
-void sh_database_reset(void)
+void sh_database_reset()
 {
   connection_status = S_FALSE;
@@ -1067,5 +1009,5 @@
 {
   int               status = 0;
-  const char      * p;
+  char            * p;
   static MYSQL    * db_conn = NULL;
   static SH_TIMEOUT sh_timer = { 0, 3600, S_TRUE };
@@ -1114,15 +1056,4 @@
 	}
 
-      /* Read in defaults from /etc/my.cnf and associated files,
-       * suggested by arjones at simultan dyndns org
-       * see: - http://dev.mysql.com/doc/refman/5.0/en/option-files.html
-       *        for the my.cnf format,
-       *      - http://dev.mysql.com/doc/refman/5.0/en/mysql-options.html
-       *        for possible options
-       * We don't check the return value because it's useless (failure due 
-       * to lack of access permission is not reported).
-       */
-      mysql_options(db_conn, MYSQL_READ_DEFAULT_GROUP, _("samhain"));
-
       status = 0;
   
@@ -1144,5 +1075,4 @@
 	    }
 	}
-      
       connection_status = S_TRUE;
     }
@@ -1169,5 +1099,5 @@
     }
 
-  if (flag_err_debug == S_TRUE)
+  if (flag_err_debug == SL_TRUE)
     {
       p = mysql_info (db_conn);
@@ -1221,30 +1151,32 @@
   long len;
 
-  if (!((end == NULL) || (val == NULL) || (size == NULL)))
-    {
-      if (val[0] != '\0')
-	{
-	  if (*size > 1)
-	    {
-	      *end = ','; ++end; (*size) -= 1;
-	      if (flag == 1) { *end = '\''; ++end; (*size) -= 1; }
-	      *end = '\0';
-	    }
-	  len = (long) strlen(val);
-	  if ((long) *size > (len+1))
-	    {
-	      (void) sl_strlcat(end, val, (size_t) *size);
-	      end   += len; (*size) -= len;
-	      if (flag == 1) { *end = '\''; ++end;  (*size) -= 1; }
-	      *end = '\0'; 
-	    }
-	}
-    }
-  
+  if (!end    || !val   || !size)
+    return end;
+
+  if (val[0] == '\0')
+    {
+      return end;
+    }
+  else
+    {
+      if (*size > 1)
+	{
+	  *end = ','; ++end; (*size) -= 1;
+	  if (flag == 1) { *end = '\''; ++end; (*size) -= 1; }
+	  *end = '\0';
+	}
+      len = (long) strlen(val);
+      if ((long) *size > (len+1))
+	{
+	  (void) sl_strlcat(end, val, (size_t) *size);
+	  end   += len; (*size) -= len;
+	  if (flag == 1) { *end = '\''; ++end;  (*size) -= 1; }
+	  *end = '\0'; 
+	}
+    }
   return end;
 }
 
-#define SH_QUERY_MAX SH_MSG_BUF
-/* define SH_QUERY_MAX 16383 */
+#define SH_QUERY_MAX 16383
 
 static
@@ -1257,4 +1189,5 @@
   char * values;
 
+  int    status;
   long   the_id;
   int    size;
@@ -1271,7 +1204,4 @@
   int  cnt;
 
-  size_t len_val;
-  size_t len_col;
-
   SL_ENTER(_("sh_database_entry"));
 
@@ -1294,10 +1224,10 @@
   /*@+bufferoverflowhigh@*/
 
-#if defined(WITH_ORACLE)
+#ifdef WITH_ORACLE
   /* Oracle needs some help for the time format (fix by Michael Somers)
    */
   (void)
   sl_snprintf (values, SH_QUERY_MAX,  
-	       _("(:1,%s,%c%s%c,to_date(%c%s%c,'YYYY-MM-DD HH24:MI:SS'),%c%s%c,%c%s%c"),
+	       _("(%s,%c%s%c,to_date(%c%s%c,'YYYY-MM-DD HH24:MI:SS'),%c%s%c,%c%s%c"),
                id >= 0 ? num : _("NULL"),
                '\'', db_entry->host,'\'', 
@@ -1307,21 +1237,4 @@
                (db_entry->msg[0] == '\0' ? _("NULL") : db_entry->msg),
                '\'');
-  (void) sl_snprintf (columns, 1023, 
-		      _("(log_index,log_ref,log_host,log_time,log_sev,log_msg"));
-#elif defined(WITH_POSTGRES)
-  /* Prepare query for PQexecParams
-   */
-  (void)
-  sl_snprintf (values, SH_QUERY_MAX, 
-	       _("($1,%s,%c%s%c,%c%s%c,%c%s%c,%c%s%c"),
-	       id >= 0 ? num : _("NULL"),
-	       '\'', db_entry->host,'\'', 
-	       '\'', db_entry->time,'\'', 
-	       '\'', db_entry->sev, '\'',
-	       '\'', 
-	       (db_entry->msg[0] == '\0' ? _("NULL") : db_entry->msg), 
-	       '\'');
-  (void) sl_snprintf (columns, 1023, 
-		      _("(log_index,log_ref,log_host,log_time,log_sev,log_msg"));
 #else
   (void)
@@ -1334,8 +1247,8 @@
 	       (db_entry->msg[0] == '\0' ? _("NULL") : db_entry->msg), 
 	       '\'');
+#endif
+
   (void) sl_snprintf (columns, 1023, 
 		      _("(log_ref,log_host,log_time,log_sev,log_msg"));
-#endif
-
 
   /*@-type@*//* byte* versus char[..] */
@@ -1354,11 +1267,8 @@
   /*@+type@*/
 
-  len_val = strlen(values);
-  size    =  (int) (SH_QUERY_MAX - len_val);
-  end     =  values + len_val;
-
-  len_col = strlen(columns);
-  c_size  =  1023   - (int) len_col; /* sizeof(colums) == 1024 */
-  c_end   =  columns + len_col;
+  size   =  (int) (SH_QUERY_MAX - strlen(values));
+  end    =  values + strlen(values);
+  c_size =  1023   - (int) strlen(columns); /* sizeof(colums) == 1024 */
+  c_end  =  columns + strlen(columns);
 
   i = 4;
@@ -1366,10 +1276,4 @@
   while (attr_tab[i].attr != NULL)
     {
-      if (SH_SLOT_CHECKFLAGS == attr_tab[i].val) {
-	if (db_entry->ulong_data[attr_tab[i].val-START_SEC_LONGS] == 0 &&
-	    db_entry->ulong_data[attr_tab[i+1].val-START_SEC_LONGS] == 0)
-	  { i+= 2; continue; } 
-      }
-
       if (attr_tab[i].size != 0)
 	{
@@ -1386,26 +1290,20 @@
 	  if (p != end)
 	    {
-	      if ((attr_tab[i].val != SH_SLOT_HOST) &&
-		  (attr_tab[i].val != SH_SLOT_GROUP))
-		{
-		  c_end = null_or_val (c_end, attr_tab[i].attr, &c_size,0);
-		}
+	      /* 
+	       * 'host' is a reserved word in SQL
+	       */
+	      if (attr_tab[i].val == SH_SLOT_HOST)
+		c_end = null_or_val (c_end, _("fromhost"), &c_size,0);
+	      /* 
+	       * 'group' is a reserved word in SQL
+	       */
+	      else if (attr_tab[i].val == SH_SLOT_GROUP)
+		c_end = null_or_val (c_end, _("grp"), &c_size,0);
 	      else
-		{
-		  /* 
-		   * 'host' is a reserved word in SQL
-		   */
-		  if (attr_tab[i].val == SH_SLOT_HOST)
-		    c_end = null_or_val (c_end, _("fromhost"), &c_size,0);
-		  /* 
-		   * 'group' is a reserved word in SQL
-		   */
-		  else /* if (attr_tab[i].val == SH_SLOT_GROUP) */
-		    c_end = null_or_val (c_end, _("grp"), &c_size,0);
-		}
+		c_end = null_or_val (c_end, attr_tab[i].attr, &c_size,0);
 	    }
 	  /*@-type@*//* byte* versus char[..] */
 	  if (attr_tab[i].inHash == 1 && 
-	      *((char *)(db_entry)+attr_tab[i].off) != '\0')
+	      ((char *)(db_entry)+attr_tab[i].off) != '\0')
 	    {
 	      (void)md5Update(&crc, 
@@ -1419,6 +1317,6 @@
 	{
 	  (void)
-	  sl_snprintf(end, (size_t)(size-1), _(",\'%lu\'"), 
-		      db_entry->ulong_data[attr_tab[i].val-START_SEC_LONGS]);
+	  sl_snprintf(end, (size_t)(size-1), _(",\'%ld\'"), 
+		      db_entry->long_data[attr_tab[i].val-START_SEC_LONGS]);
 	  while (*end != '\0') { ++end; --size; }
 	  (void) sl_snprintf(c_end, (size_t)(c_size-1), 
